<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<xsl:stylesheet 
   xmlns:doc="urn:oasis:names:specification:ubl:schema:xsd:Catalogue-2"
   xmlns:cac="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2"
   xmlns:cbc="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2"
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:xs="http://www.w3.org/2001/XMLSchema"
   version="2.0">
   
   
   <xsl:output method="xml" indent="yes" />
  
   

   <xsl:template match="doc:Catalogue/cac:CatalogueLine">
 
 
 
  
<!-- Test to see if "for-each-group" performs better that "following-sibling"-->
      
      <!--      <xsl:for-each-group select="../cac:CatalogueLine" group-by="cbc:ID">
         
       <xsl:if test="count(current-group()) &gt; 1">
            <Error>
               <xsl:attribute name="context">
                  <xsl:value-of select="concat(name(parent::*),'/',name())"/>
               </xsl:attribute>
               <Pattern>count(current-group()) &gt; 1</Pattern>
               <Description>[F-CAT248] CatalogueLine.ID must be unique within the document instance</Description>
               <Xpath>
                  <xsl:for-each select="ancestor-or-self::*">/<xsl:value-of select="name()"/>[<xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>]</xsl:for-each>
               </Xpath>
            </Error>
         </xsl:if>
      </xsl:for-each-group>-->
   
   
   
<!--       Original test -->
      <xsl:if test="./cbc:ID = ./following-sibling::*/cbc:ID">
         <Error>
            <xsl:attribute name="context">
               <xsl:value-of select="concat(name(parent::*),'/',name())"/>
            </xsl:attribute>
            <Pattern>./cbc:ID = ./following-sibling::*/cbc:ID</Pattern>
            <Description>[F-CAT248] CatalogueLine.ID must be unique within the document instance</Description>
            <Xpath>
               <xsl:for-each select="ancestor-or-self::*">/<xsl:value-of select="name()"/>[<xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>]</xsl:for-each>
            </Xpath>
         </Error>
      </xsl:if>
   
   

</xsl:template>
   
</xsl:stylesheet>